Skip to content

HTTPS clone URL

Subversion checkout URL

You can clone with HTTPS or Subversion.

Download ZIP
Fetching contributors…

Cannot retrieve contributors at this time

70 lines (49 sloc) 1.85 kb
INTRODUCTION
Parslet makes developing complex parsers easy. It does so by
* providing the best error reporting possible
* not generating reams of code for you to debug
Parslet takes the long way around to make your job easier. It allows for
incremental language construction. Often, you start out small, implementing
the atoms of your language first; _parslet_ takes pride in making this
possible.
Eager to try this out? Please see the associated web site:
http://kschiess.github.com/parslet
SYNOPSIS
require 'parslet'
include Parslet
# parslet parses strings
str('foo').
parse('foo') # => "foo"@0
# it matches character sets
match['abc'].parse('a') # => "a"@0
match['abc'].parse('b') # => "b"@0
match['abc'].parse('c') # => "c"@0
# and it annotates its output
str('foo').as(:important_bit).
parse('foo') # => {:important_bit=>"foo"@0}
# you can construct parsers with just a few lines
quote = str('"')
simple_string = quote >> (quote.absent? >> any).repeat >> quote
simple_string.
parse('"Simple Simple Simple"') # => "\"Simple Simple Simple\""@0
# or by making a fuss about it
class Smalltalk < Parslet::Parser
root :smalltalk
rule(:smalltalk) { statements }
rule(:statements) {
# insert smalltalk parser here (outside of the scope of this readme)
}
end
# and then
Smalltalk.new.parse('smalltalk')
COMPATIBILITY
This library should work with most rubies. I've tested it with MRI 1.8
(except 1.8.6), 1.9, rbx-head, jruby. Please report as a bug if you encounter
issues.
Note that due to Ruby 1.8 internals, Unicode parsing is not supported on that
version.
On Mac OS X Lion, ruby-1.8.7-p352 has been known to segfault. Use
ruby-1.8.7-p334 for better results.
STATUS
At version 1.4.0 - See HISTORY.txt for changes.
(c) 2010, 2011, 2012 Kaspar Schiess
Jump to Line
Something went wrong with that request. Please try again.